# GstAudioVisualizer

A baseclass for scopes (visualizers). It takes care of re-fitting the audio-rate to video-rate and handles renegotiation (downstream video size changes).

It also provides several background shading effects. These effects are applied to a previous picture before the `render()` implementation can draw a new frame.

## GstAudioVisualizer

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstAudioVisualizer

### Members

`parent` (GstElement) –
No description available
`req_spf` (guint) –
No description available
`vinfo` (GstVideoInfo) –
No description available
`ainfo` (GstAudioInfo) –
No description available

### Class structure

#### GstAudioVisualizerClass

### GstPbutils.AudioVisualizerClass

## GstPbutils.AudioVisualizer

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstPbutils.AudioVisualizer

### Members

`parent` (Gst.Element) –
No description available
`req_spf` (Number) –
No description available
`vinfo` (GstVideo.VideoInfo) –
No description available
`ainfo` (GstAudio.AudioInfo) –
No description available

## GstPbutils.AudioVisualizer

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstPbutils.AudioVisualizer

### Members

`parent` (Gst.Element) –
No description available
`req_spf` (int) –
No description available
`vinfo` (GstVideo.VideoInfo) –
No description available
`ainfo` (GstAudio.AudioInfo) –
No description available

### Properties

#### shade-amount

    “shade-amount” guint

Flags : Read / Write

#### shade-amount

    “shade-amount” Number

Flags : Read / Write

#### shade_amount

    “self.props.shade_amount” int

Flags : Read / Write

#### shader

    “shader” GstAudioVisualizerShader *

Flags : Read / Write

#### shader

    “shader” GstPbutils.AudioVisualizerShader

Flags : Read / Write

#### shader

    “self.props.shader” GstPbutils.AudioVisualizerShader

Flags : Read / Write

### Virtual Methods

#### decide_allocation

    gboolean
    decide_allocation (GstAudioVisualizer * scope,
                       GstQuery * query)

Parameters:

`scope` –
No description available
`query` –
No description available
Returns –
No description available

#### vfunc_decide_allocation

    function vfunc_decide_allocation(scope: GstPbutils.AudioVisualizer, query: Gst.Query): {
        // javascript implementation of the 'decide_allocation' virtual method
    }

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
`query` (Gst.Query) –
No description available
Returns (Number) –
No description available

#### do_decide_allocation

    def do_decide_allocation (scope, query):
        #python implementation of the 'decide_allocation' virtual method

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
`query` (Gst.Query) –
No description available
Returns (bool) –
No description available

#### render

    gboolean
    render (GstAudioVisualizer * scope,
            GstBuffer * audio,
            GstVideoFrame * video)

Parameters:

`scope` –
No description available
`audio` –
No description available
`video` –
No description available
Returns –
No description available

#### vfunc_render

    function vfunc_render(scope: GstPbutils.AudioVisualizer, audio: Gst.Buffer, video: GstVideo.VideoFrame): {
        // javascript implementation of the 'render' virtual method
    }

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
`audio` (Gst.Buffer) –
No description available
`video` (GstVideo.VideoFrame) –
No description available
Returns (Number) –
No description available

#### do_render

    def do_render (scope, audio, video):
        #python implementation of the 'render' virtual method

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
`audio` (Gst.Buffer) –
No description available
`video` (GstVideo.VideoFrame) –
No description available
Returns (bool) –
No description available

#### setup

    gboolean
    setup (GstAudioVisualizer * scope)

Parameters:

`scope` –
No description available
Returns –
No description available

#### vfunc_setup

    function vfunc_setup(scope: GstPbutils.AudioVisualizer): {
        // javascript implementation of the 'setup' virtual method
    }

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
Returns (Number) –
No description available

#### do_setup

    def do_setup (scope):
        #python implementation of the 'setup' virtual method

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
Returns (bool) –
No description available

## Function Macros

### GST_IS_SYNAESTHESIA

    #define GST_IS_SYNAESTHESIA(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_AUDIO_VISUALIZER))

### GST_IS_SYNAESTHESIA_CLASS

    #define GST_IS_SYNAESTHESIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_AUDIO_VISUALIZER))

## Enumerations

### GstAudioVisualizerShader

Different types of supported background shading functions.

##### Members

`GST_AUDIO_VISUALIZER_SHADER_NONE` (0) –

no shading

`GST_AUDIO_VISUALIZER_SHADER_FADE` (1) –

plain fading

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_UP` (2) –

fade and move up

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_DOWN` (3) –

fade and move down

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_LEFT` (4) –

fade and move left

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_RIGHT` (5) –

fade and move right

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_HORIZ_OUT` (6) –

fade and move horizontally out

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_HORIZ_IN` (7) –

fade and move horizontally in

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_VERT_OUT` (8) –

fade and move vertically out

`GST_AUDIO_VISUALIZER_SHADER_FADE_AND_MOVE_VERT_IN` (9) –

fade and move vertically in

### GstPbutils.AudioVisualizerShader

Different types of supported background shading functions.

##### Members

`GstPbutils.AudioVisualizerShader.NONE` (0) –

no shading

`GstPbutils.AudioVisualizerShader.FADE` (1) –

plain fading

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_UP` (2) –

fade and move up

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_DOWN` (3) –

fade and move down

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_LEFT` (4) –

fade and move left

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_RIGHT` (5) –

fade and move right

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_HORIZ_OUT` (6) –

fade and move horizontally out

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_HORIZ_IN` (7) –

fade and move horizontally in

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_VERT_OUT` (8) –

fade and move vertically out

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_VERT_IN` (9) –

fade and move vertically in

### GstPbutils.AudioVisualizerShader

Different types of supported background shading functions.

##### Members

`GstPbutils.AudioVisualizerShader.NONE` (0) –

no shading

`GstPbutils.AudioVisualizerShader.FADE` (1) –

plain fading

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_UP` (2) –

fade and move up

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_DOWN` (3) –

fade and move down

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_LEFT` (4) –

fade and move left

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_RIGHT` (5) –

fade and move right

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_HORIZ_OUT` (6) –

fade and move horizontally out

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_HORIZ_IN` (7) –

fade and move horizontally in

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_VERT_OUT` (8) –

fade and move vertically out

`GstPbutils.AudioVisualizerShader.FADE_AND_MOVE_VERT_IN` (9) –

fade and move vertically in

## Callbacks

### GstAudioVisualizerShaderFunc

    (*GstAudioVisualizerShaderFunc) (GstAudioVisualizer * scope,
                                     const GstVideoFrame * s,
                                     GstVideoFrame * d)

Parameters:

`scope` –
No description available
`s` –
No description available
`d` –
No description available

### GstPbutils.AudioVisualizerShaderFunc

    function GstPbutils.AudioVisualizerShaderFunc(scope: GstPbutils.AudioVisualizer, s: GstVideo.VideoFrame, d: GstVideo.VideoFrame): {
        // javascript wrapper for 'GstAudioVisualizerShaderFunc'
    }

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
`s` (GstVideo.VideoFrame) –
No description available
`d` (GstVideo.VideoFrame) –
No description available

### GstPbutils.AudioVisualizerShaderFunc

    def GstPbutils.AudioVisualizerShaderFunc (scope, s, d):
        #python wrapper for 'GstAudioVisualizerShaderFunc'

Parameters:

`scope` (GstPbutils.AudioVisualizer) –
No description available
`s` (GstVideo.VideoFrame) –
No description available
`d` (GstVideo.VideoFrame) –
No description available

The results of the search are